diff -ruN tarsnap-autoconf-1.0.33/libcperciva/network/network_buf.c tarsnap-autoconf-1.0.34/libcperciva/network/network_buf.c
--- tarsnap-autoconf-1.0.33/libcperciva/network/network_buf.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/network/network_buf.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,297 @@
+#include <sys/types.h>
+#include <sys/socket.h>
+
+#include <assert.h>
+#include <errno.h>
+#include <limits.h>
+#include <signal.h>
+#include <stdint.h>
+#include <stdlib.h>
+#include <unistd.h>
+
+#include "events.h"
+#include "warnp.h"
+
+#include "network.h"
+
+/**
+ * We use three methods to prevent SIGPIPE from being sent, in order of
+ * preference:
+ * 1. The MSG_NOSIGNAL send(2) flag.
+ * 2. The SO_NOSIGPIPE socket option.
+ * 3. Blocking the SIGPIPE signal.
+ */
+#ifdef MSG_NOSIGNAL
+#define USE_MSG_NOSIGNAL
+#else /* !MSG_NOSIGNAL */
+#define MSG_NOSIGNAL 0
+#ifdef SO_NOSIGPIPE
+#define USE_SO_NOSIGPIPE
+#else /* !MSG_NOSIGNAL, !SO_NOSIGPIPE */
+#define USE_SIGNAL
+#endif /* !MSG_NOSIGNAL, !SO_NOSIGPIPE */
+#endif /* !MSG_NOSIGNAL */
+
+struct network_buf_cookie {
+	int (*callback)(void *, ssize_t);
+	void * cookie;
+	int fd;
+	uint8_t * buf;
+	size_t buflen;
+	size_t minlen;
+	size_t bufpos;
+	ssize_t (* sendrecv)(int, void *, size_t, int);
+	int op;
+	int flags;
+};
+
+static int docallback(struct network_buf_cookie *, size_t);
+static int callback_buf(void *);
+static struct network_buf_cookie * network_buf(int, uint8_t *, size_t,
+    size_t, int (*)(void *, ssize_t), void *,
+    ssize_t (*)(int, void *, size_t, int), int, int);
+static void cancel(void *);
+
+/* Invoke the callback, clean up, and return the callback's status. */
+static int
+docallback(struct network_buf_cookie * C, size_t nbytes)
+{
+	int rc;
+
+	/* Invoke the callback. */
+	rc = (C->callback)(C->cookie, nbytes);
+
+	/* Clean up. */
+	free(C);
+
+	/* Return the callback's status. */
+	return (rc);
+}
+
+/* The socket is ready for reading/writing. */
+static int
+callback_buf(void * cookie)
+{
+	struct network_buf_cookie * C = cookie;
+	size_t oplen;
+	ssize_t len;
+#ifdef USE_SO_NOSIGPIPE
+	int val;
+#endif
+#ifdef USE_SIGNAL
+	void (*oldsig)(int);
+#endif
+
+	/* Make sure we don't get a SIGPIPE. */
+#ifdef USE_SO_NOSIGPIPE
+	val = 1;
+	if (setsockopt(C->fd, SOL_SOCKET, SO_NOSIGPIPE, &val, sizeof(int))) {
+		warnp("setsockopt(SO_NOSIGPIPE)");
+		goto failed;
+	}
+#endif
+#ifdef USE_SIGNAL
+	if ((oldsig = signal(SIGPIPE, SIG_IGN)) == SIG_ERR) {
+		warnp("signal(SIGPIPE)");
+		goto failed;
+	}
+#endif
+
+	/* Attempt to read/write data to/from the buffer. */
+	oplen = C->buflen - C->bufpos;
+	len = (C->sendrecv)(C->fd, C->buf + C->bufpos, oplen, C->flags);
+
+	/* Undo whatever we did to prevent SIGPIPEs. */
+#ifdef USE_SO_NOSIGPIPE
+	val = 0;
+	if (setsockopt(C->fd, SOL_SOCKET, SO_NOSIGPIPE, &val, sizeof(int))) {
+		warnp("setsockopt(SO_NOSIGPIPE)");
+		goto failed;
+	}
+#endif
+#ifdef USE_SIGNAL
+	if (signal(SIGPIPE, oldsig) == SIG_ERR) {
+		warnp("signal(SIGPIPE)");
+		goto failed;
+	}
+#endif
+
+	/* Failure? */
+	if (len == -1) {
+		/* Was it really an error, or just a try-again? */
+		if ((errno == EAGAIN) ||
+		    (errno == EWOULDBLOCK) ||
+		    (errno == EINTR))
+			goto tryagain;
+
+		/* Something went wrong. */
+		goto failed;
+	} else if (len == 0) {
+		/* The socket was shut down by the remote host. */
+		goto eof;
+	}
+
+	/* We processed some data.  Do we need to keep going? */
+	if ((C->bufpos += len) < C->minlen)
+		goto tryagain;
+
+	/* Invoke the callback and return. */
+	return (docallback(C, C->bufpos));
+
+tryagain:
+	/* Reset the event. */
+	if (events_network_register(callback_buf, C, C->fd, C->op))
+		goto failed;
+
+	/* Callback was reset. */
+	return (0);
+
+eof:
+	/* Sanity-check: This should only occur for reads. */
+	assert(C->op == EVENTS_NETWORK_OP_READ);
+
+	/* Invoke the callback with an EOF status and return. */
+	return (docallback(C, 0));
+
+failed:
+	/* Invoke the callback with a failure status and return. */
+	return (docallback(C, -1));
+}
+
+/**
+ * network_buf(fd, buf, buflen, minlen, callback, cookie, sendrecv, op, flags):
+ * Asynchronously read/write up to ${buflen} bytes of data from/to ${fd}
+ * to/from ${buf}.  When at least ${minlen} bytes have been read/written,
+ * invoke ${callback}(${cookie}, nbytes), where nbytes is 0 on EOF or -1 on
+ * error and the number of bytes read/written (between ${minlen} and ${buflen}
+ * inclusive) otherwise.  Return a cookie which can be passed to buf_cancel
+ * in order to cancel the read/write.
+ */
+static struct network_buf_cookie *
+network_buf(int fd, uint8_t * buf, size_t buflen, size_t minlen,
+    int (* callback)(void *, ssize_t), void * cookie,
+    ssize_t (* sendrecv)(int, void *, size_t, int), int op, int flags)
+{
+	struct network_buf_cookie * C;
+
+	/* Sanity-check: # bytes must fit into a ssize_t. */
+	assert(buflen <= SSIZE_MAX);
+
+	/* Bake a cookie. */
+	if ((C = malloc(sizeof(struct network_buf_cookie))) == NULL)
+		goto err0;
+	C->callback = callback;
+	C->cookie = cookie;
+	C->fd = fd;
+	C->buf = buf;
+	C->buflen = buflen;
+	C->minlen = minlen;
+	C->bufpos = 0;
+	C->sendrecv = sendrecv;
+	C->op = op;
+	C->flags = flags;
+
+	/* Register a callback for network readiness. */
+	if (events_network_register(callback_buf, C, C->fd, C->op))
+		goto err1;
+
+	/* Success! */
+	return (C);
+
+err1:
+	free(C);
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/* Cancel the read/write. */
+static void
+cancel(void * cookie)
+{
+	struct network_buf_cookie * C = cookie;
+
+	/* Kill the network event. */
+	events_network_cancel(C->fd, C->op);
+
+	/* Free the cookie. */
+	free(C);
+}
+
+/**
+ * network_read(fd, buf, buflen, minread, callback, cookie):
+ * Asynchronously read up to ${buflen} bytes of data from ${fd} into ${buf}.
+ * When at least ${minread} bytes have been read or on error, invoke
+ * ${callback}(${cookie}, lenread), where lenread is 0 on EOF or -1 on error,
+ * and the number of bytes read (between ${minread} and ${buflen} inclusive)
+ * otherwise.  Return a cookie which can be passed to network_read_cancel in
+ * order to cancel the read.
+ */
+void *
+network_read(int fd, uint8_t * buf, size_t buflen, size_t minread,
+    int (* callback)(void *, ssize_t), void * cookie)
+{
+
+	/* Make sure buflen is non-zero. */
+	if (buflen == 0) {
+		warn0("Programmer error: Cannot read zero-byte buffer");
+		return (NULL);
+	}
+
+	/* Get network_buf to set things up for us. */
+	return (network_buf(fd, buf, buflen, minread, callback, cookie, recv,
+	    EVENTS_NETWORK_OP_READ, 0));
+}
+
+/**
+ * network_read_cancel(cookie):
+ * Cancel the buffer read for which the cookie ${cookie} was returned by
+ * network_read.  Do not invoke the callback associated with the read.
+ */
+void
+network_read_cancel(void * cookie)
+{
+
+	/* Get cancel to do the work for us. */
+	cancel(cookie);
+}
+
+/**
+ * network_write(fd, buf, buflen, minwrite, callback, cookie):
+ * Asynchronously write up to ${buflen} bytes of data from ${buf} to ${fd}.
+ * When at least ${minwrite} bytes have been written or on error, invoke
+ * ${callback}(${cookie}, lenwrit), where lenwrit is -1 on error and the
+ * number of bytes written (between ${minwrite} and ${buflen} inclusive)
+ * otherwise.  Return a cookie which can be passed to network_write_cancel in
+ * order to cancel the write.
+ */
+void *
+network_write(int fd, const uint8_t * buf, size_t buflen, size_t minwrite,
+    int (* callback)(void *, ssize_t), void * cookie)
+{
+
+	/* Make sure buflen is non-zero. */
+	if (buflen == 0) {
+		warn0("Programmer error: Cannot write zero-byte buffer");
+		return (NULL);
+	}
+
+	/* Get network_buf to set things up for us. */
+	return (network_buf(fd, (uint8_t *)(uintptr_t)buf, buflen, minwrite,
+	    callback, cookie,
+	    (ssize_t (*)(int, void *, size_t, int))send,
+	    EVENTS_NETWORK_OP_WRITE, MSG_NOSIGNAL));
+}
+
+/**
+ * network_write_cancel(cookie):
+ * Cancel the buffer write for which the cookie ${cookie} was returned by
+ * network_write.  Do not invoke the callback associated with the write.
+ */
+void
+network_write_cancel(void * cookie)
+{
+
+	/* Get cancel to do the work for us. */
+	cancel(cookie);
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/network/network_connect.c tarsnap-autoconf-1.0.34/libcperciva/network/network_connect.c
--- tarsnap-autoconf-1.0.33/libcperciva/network/network_connect.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/network/network_connect.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,255 @@
+#include <sys/types.h>
+#include <sys/select.h>
+#include <sys/socket.h>
+
+#include <assert.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+
+#include "events.h"
+#include "sock.h"
+
+#include "network.h"
+
+struct connect_cookie {
+	int (* callback)(void *, int);
+	void * cookie;
+	struct sock_addr * const * sas;
+	struct timeval timeo;
+	void * cookie_immediate;
+	int s;
+	int timeo_enabled;
+	void * cookie_timeo;
+};
+
+static int tryconnect(struct connect_cookie *);
+
+/* Invoke the upstream callback and clean up. */
+static int
+docallback(void * cookie)
+{
+	struct connect_cookie * C = cookie;
+	int rc;
+
+	/* Invoke the upstream callback. */
+	rc = (C->callback)(C->cookie, C->s);
+
+	/* Free the cookie. */
+	free(C);
+
+	/* Return status from upstream callback. */
+	return (rc);
+}
+
+/* An address failed to connect. */
+static int
+dofailed(struct connect_cookie * C)
+{
+
+	/* Close the socket which failed to connect. */
+	close(C->s);
+
+	/* We don't have an open socket any more. */
+	C->s = -1;
+
+	/* This address didn't work. */
+	C->sas++;
+
+	/* Try other addresses until we run out of options. */
+	return (tryconnect(C));
+}
+
+/* Callback when connect(2) succeeds or fails. */
+static int
+callback_connect(void * cookie)
+{
+	struct connect_cookie * C = cookie;
+	int sockerr;
+	socklen_t sockerrlen = sizeof(int);
+
+	/* Stop waiting for the timer callback. */
+	if (C->cookie_timeo != NULL) {
+		events_timer_cancel(C->cookie_timeo);
+		C->cookie_timeo = NULL;
+	}
+
+	/* Did we succeed? */
+	if (getsockopt(C->s, SOL_SOCKET, SO_ERROR, &sockerr, &sockerrlen))
+		goto err1;
+	if (sockerr != 0)
+		return (dofailed(C));
+
+	/*
+	 * Perform the callback (this can be done here rather than being
+	 * scheduled as an immediate callback, as we're already running from
+	 * callback context).
+	 */
+	return (docallback(C));
+
+err1:
+	close(C->s);
+	free(C);
+
+	/* Fatal error! */
+	return (-1);
+}
+
+/* Callback when a timer expires. */
+static int
+callback_timeo(void * cookie)
+{
+	struct connect_cookie * C = cookie;
+
+	/* We're not waiting for a timer callback any more. */
+	C->cookie_timeo = NULL;
+
+	/* This connect attempt failed. */
+	return (dofailed(C));
+}
+
+/* Try to launch a connection.  Free the cookie on fatal errors. */
+static int
+tryconnect(struct connect_cookie * C)
+{
+
+	/* Try addresses until we find one which doesn't fail immediately. */
+	for (; C->sas[0] != NULL; C->sas++) {
+		/* Can we try to connect to this address? */
+		if ((C->s = sock_connect_nb(C->sas[0])) != -1)
+			break;
+	}
+
+	/* Did we run out of addresses to try? */
+	if (C->sas[0] == NULL)
+		goto failed;
+
+	/* If we've been asked to have a timeout, set one. */
+	if (C->timeo_enabled) {
+		if ((C->cookie_timeo = events_timer_register(callback_timeo,
+		    C, &C->timeo)) == NULL)
+			goto err1;
+	} else {
+		C->cookie_timeo = NULL;
+	}
+
+	/* Wait until this socket connects or fails to do so. */
+	if (events_network_register(callback_connect, C, C->s,
+	    EVENTS_NETWORK_OP_WRITE))
+		goto err2;
+
+	/* Success! */
+	return (0);
+
+failed:
+	/* Schedule a callback. */
+	if ((C->cookie_immediate =
+	    events_immediate_register(docallback, C, 0)) == NULL)
+		goto err1;
+
+	/* Failure successfully handled. */
+	return (0);
+
+err2:
+	if (C->cookie_timeo != NULL)
+		events_timer_cancel(C->cookie_timeo);
+err1:
+	if (C->s != -1)
+		close(C->s);
+	free(C);
+
+	/* Fatal error. */
+	return (-1);
+}
+
+/**
+ * network_connect(sas, callback, cookie):
+ * Iterate through the addresses in ${sas}, attempting to create and connect
+ * a non-blocking socket.  Once connected, invoke ${callback}(${cookie}, s)
+ * where s is the connected socket; upon fatal error or if there are no
+ * addresses remaining to attempt, invoke ${callback}(${cookie}, -1).  Return
+ * a cookie which can be passed to network_connect_cancel in order to cancel
+ * the connection attempt.
+ */
+void *
+network_connect(struct sock_addr * const * sas,
+    int (* callback)(void *, int), void * cookie)
+{
+
+	/* Let network_connect_timeo handle this. */
+	return (network_connect_timeo(sas, NULL, callback, cookie));
+}
+
+/**
+ * network_connect_timeo(sas, timeo, callback, cookie):
+ * Behave as network_connect, but wait a duration of at most ${timeo} for
+ * each address which is being attempted.
+ */
+void *
+network_connect_timeo(struct sock_addr * const * sas,
+    const struct timeval * timeo,
+    int (* callback)(void *, int), void * cookie)
+{
+	struct connect_cookie * C;
+
+	/* Bake a cookie. */
+	if ((C = malloc(sizeof(struct connect_cookie))) == NULL)
+		goto err0;
+	C->callback = callback;
+	C->cookie = cookie;
+	C->sas = sas;
+	C->cookie_immediate = NULL;
+	C->cookie_timeo = NULL;
+	C->s = -1;
+
+	/* Do we have a timeout? */
+	if (timeo != NULL) {
+		memcpy(&C->timeo, timeo, sizeof(struct timeval));
+		C->timeo_enabled = 1;
+	} else {
+		C->timeo_enabled = 0;
+	}
+
+	/* Try to connect to the first address. */
+	if (tryconnect(C))
+		goto err0;
+
+	/* Success! */
+	return (C);
+
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/**
+ * network_connect_cancel(cookie):
+ * Cancel the connection attempt for which ${cookie} was returned by
+ * network_connect.  Do not invoke the associated callback.
+ */
+void
+network_connect_cancel(void * cookie)
+{
+	struct connect_cookie * C = cookie;
+
+	/* We should have either an immediate callback or a socket. */
+	assert((C->cookie_immediate != NULL) || (C->s != -1));
+	assert((C->cookie_immediate == NULL) || (C->s == -1));
+
+	/* Cancel any timer. */
+	if (C->cookie_timeo != NULL)
+		events_timer_cancel(C->cookie_timeo);
+
+	/* Cancel any immediate callback. */
+	if (C->cookie_immediate != NULL)
+		events_immediate_cancel(C->cookie_immediate);
+
+	/* Close any socket. */
+	if (C->s != -1) {
+		events_network_cancel(C->s, EVENTS_NETWORK_OP_WRITE);
+		close(C->s);
+	}
+
+	/* Free the cookie. */
+	free(C);
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/asprintf.c tarsnap-autoconf-1.0.34/libcperciva/util/asprintf.c
--- tarsnap-autoconf-1.0.33/libcperciva/util/asprintf.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/asprintf.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,49 @@
+#include <stdarg.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+#include "asprintf.h"
+
+/**
+ * asprintf(ret, format, ...):
+ * Do asprintf(3) like GNU and BSD do.
+ */
+int
+asprintf(char **ret, const char *format, ...)
+{
+	va_list ap;
+	int len;
+	size_t buflen;
+
+	/* Figure out how long the string needs to be. */
+	va_start(ap, format);
+	len = vsnprintf(NULL, 0, format, ap);
+	va_end(ap);
+
+	/* Did we fail? */
+	if (len < 0)
+		goto err0;
+	buflen = (size_t)(len) + 1;
+
+	/* Allocate memory. */
+	if ((*ret = malloc(buflen)) == NULL)
+		goto err0;
+
+	/* Actually generate the string. */
+	va_start(ap, format);
+	len = vsnprintf(*ret, buflen, format, ap);
+	va_end(ap);
+
+	/* Did we fail? */
+	if (len < 0)
+		goto err1;
+
+	/* Success! */
+	return (len);
+
+err1:
+	free(*ret);
+err0:
+	/* Failure! */
+	return (-1);
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/asprintf.h tarsnap-autoconf-1.0.34/libcperciva/util/asprintf.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/asprintf.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/asprintf.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,16 @@
+#ifndef _ASPRINTF_H_
+#define _ASPRINTF_H_
+
+/* Avoid namespace collisions with BSD/GNU asprintf. */
+#ifdef asprintf
+#undef asprintf
+#endif
+#define asprintf libcperciva_asprintf
+
+/**
+ * asprintf(ret, format, ...):
+ * Do asprintf(3) like GNU and BSD do.
+ */
+int asprintf(char **, const char *, ...);
+
+#endif /* !_ASPRINTF_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/b64encode.c tarsnap-autoconf-1.0.34/libcperciva/util/b64encode.c
--- tarsnap-autoconf-1.0.33/libcperciva/util/b64encode.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/b64encode.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,120 @@
+#include <stdint.h>
+#include <string.h>
+
+#include "b64encode.h"
+
+static char b64chars[] =
+    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
+
+/**
+ * b64encode(in, out, len):
+ * Convert ${len} bytes from ${in} into RFC 1421 base-64 encoding, writing
+ * the resulting ((len + 2) / 3) * 4 bytes to ${out}; and append a NUL byte.
+ */
+void
+b64encode(const uint8_t * in, char * out, size_t len)
+{
+	uint32_t t;
+	size_t j;
+
+	/* Repeat {read up to 3 bytes; write 4 bytes} until we're done. */
+	while (len) {
+		/* Read up to 3 bytes. */
+		for (t = j = 0; j < 3; j++) {
+			t <<= 8;
+			if (j < len)
+				t += *in++;
+		}
+
+		/* Write 4 bytes. */
+		for (j = 0; j < 4; j++) {
+			if (j <= len)
+				*out++ = b64chars[(t >> 18) & 0x3f];
+			else
+				*out++ = '=';
+			t <<= 6;
+		}
+
+		/* Adjust the remaining length. */
+		if (len < 3)
+			len = 0;
+		else
+			len -= 3;
+	}
+
+	/* NUL terminate. */
+	*out++ = '\0';
+}
+
+/**
+ * b64decode(in, inlen, out, outlen):
+ * Convert ${inlen} bytes of RFC 1421 base-64 encoding from ${in}, writing
+ * the resulting bytes to ${out}; and pass the number of bytes output back
+ * via ${outlen}.  The buffer ${out} must contain at least (inlen/4)*3 bytes
+ * of space; but ${outlen} might be less than this.  Return non-zero if the
+ * input ${in} is not valid base-64 encoded text.
+ */
+int
+b64decode(const char * in, size_t inlen, uint8_t * out, size_t * outlen)
+{
+	uint32_t t;
+	size_t deadbytes = 0;
+	size_t i;
+
+	/* We must have a multiple of 4 input bytes. */
+	if (inlen % 4 != 0)
+		goto bad;
+
+	/* Check that we have valid input and count trailing '='s. */
+	for (i = 0; i < inlen; i++) {
+		/* Must be characters from our b64 character set. */
+		if ((in[i] == '\0') || (strchr(b64chars, in[i]) == NULL))
+			goto bad;
+
+		/* Is this a '=' character? */
+		if (in[i] == '=')
+			deadbytes += 1;
+
+		/* No non-'=' bytes after a '=' byte. */
+		if ((in[i] != '=') && (deadbytes > 0))
+			goto bad;
+	}
+
+	/* Can't have more than 2 trailing '=' bytes. */
+	if (deadbytes > 2)
+		goto bad;
+
+	/* We have no output yet. */
+	*outlen = 0;
+
+	/* Loop until we run out of data. */
+	while (inlen) {
+		/* Parse 4 bytes. */
+		for (t = 0, i = 0; i < 4; i++) {
+			t <<= 6;
+			t += (strchr(b64chars, in[i]) - b64chars) & 0x3f;
+		}
+
+		/* Output 3 bytes. */
+		for (i = 0; i < 3; i++) {
+			out[i] = t >> 16;
+			t <<= 8;
+		}
+
+		/* Adjust pointers and lengths for the completed block. */
+		in += 4;
+		inlen -= 4;
+		out += 3;
+		*outlen += 3;
+	}
+
+	/* Ignore dead bytes. */
+	*outlen -= deadbytes;
+
+	/* Success! */
+	return (0);
+
+bad:
+	/* The input is not valid base-64 encoded text. */
+	return (1);
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/b64encode.h tarsnap-autoconf-1.0.34/libcperciva/util/b64encode.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/b64encode.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/b64encode.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,24 @@
+#ifndef _B64ENCODE_H_
+#define _B64ENCODE_H_
+
+#include <stddef.h>
+#include <stdint.h>
+
+/**
+ * b64encode(in, out, len):
+ * Convert ${len} bytes from ${in} into RFC 1421 base-64 encoding, writing
+ * the resulting ((len + 2) / 3) * 4 bytes to ${out}; and append a NUL byte.
+ */
+void b64encode(const uint8_t *, char *, size_t);
+
+/**
+ * b64decode(in, inlen, out, outlen):
+ * Convert ${inlen} bytes of RFC 1421 base-64 encoding from ${in}, writing
+ * the resulting bytes to ${out}; and pass the number of bytes output back
+ * via ${outlen}.  The buffer ${out} must contain at least (inlen/4)*3 bytes
+ * of space; but ${outlen} might be less than this.  Return non-zero if the
+ * input ${in} is not valid base-64 encoded text.
+ */
+int b64decode(const char *, size_t, uint8_t *, size_t *);
+
+#endif /* !_B64ENCODE_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/ctassert.h tarsnap-autoconf-1.0.34/libcperciva/util/ctassert.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/ctassert.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/ctassert.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,19 @@
+#ifndef _CTASSERT_H_
+#define _CTASSERT_H_
+
+/*
+ * CTASSERT(foo) will produce a compile-time error if "foo" is not a constant
+ * expression which evaluates to a non-zero value.
+ */
+
+/* Kill any existing definition, just in case it's different. */
+#ifdef CTASSERT
+#undef CTASSERT
+#endif
+
+/* Define using libcperciva namespace to avoid collisions. */
+#define CTASSERT(x)			libcperciva_CTASSERT(x, __LINE__)
+#define libcperciva_CTASSERT(x, y)	libcperciva__CTASSERT(x, y)
+#define libcperciva__CTASSERT(x, y)	typedef char libcperciva__assert ## y[(x) ? 1 : -1]
+
+#endif /* !_CTASSERT_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/entropy.c tarsnap-autoconf-1.0.34/libcperciva/util/entropy.c
--- tarsnap-autoconf-1.0.33/libcperciva/util/entropy.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/entropy.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,76 @@
+#include <fcntl.h>
+#include <limits.h>
+#include <stdint.h>
+#include <unistd.h>
+
+#include "warnp.h"
+
+#include "entropy.h"
+
+/**
+ * XXX Portability
+ * XXX We obtain random bytes from the operating system by opening
+ * XXX /dev/urandom and reading them from that device; this works on
+ * XXX modern UNIX-like operating systems but not on systems like
+ * XXX win32 where there is no concept of /dev/urandom.
+ */
+
+/**
+ * entropy_read(buf, buflen):
+ * Fill the given buffer with random bytes provided by the operating system.
+ */
+int
+entropy_read(uint8_t * buf, size_t buflen)
+{
+	int fd;
+	ssize_t lenread;
+
+	/* Sanity-check the buffer size. */
+	if (buflen > SSIZE_MAX) {
+		warn0("Programmer error: "
+		    "Trying to read insane amount of random data: %zu",
+		    buflen);
+		goto err0;
+	}
+
+	/* Open /dev/urandom. */
+	if ((fd = open("/dev/urandom", O_RDONLY)) == -1) {
+		warnp("open(/dev/urandom)");
+		goto err0;
+	}
+
+	/* Read bytes until we have filled the buffer. */
+	while (buflen > 0) {
+		if ((lenread = read(fd, buf, buflen)) == -1) {
+			warnp("read(/dev/urandom)");
+			goto err1;
+		}
+
+		/* The random device should never EOF. */
+		if (lenread == 0) {
+			warn0("EOF on /dev/urandom?");
+			goto err1;
+		}
+
+		/* We're partly done. */
+		buf += lenread;
+		buflen -= lenread;
+	}
+
+	/* Close the device. */
+	while (close(fd) == -1) {
+		if (errno != EINTR) {
+			warnp("close(/dev/urandom)");
+			goto err0;
+		}
+	}
+
+	/* Success! */
+	return (0);
+
+err1:
+	close(fd);
+err0:
+	/* Failure! */
+	return (-1);
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/entropy.h tarsnap-autoconf-1.0.34/libcperciva/util/entropy.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/entropy.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/entropy.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,13 @@
+#ifndef _ENTROPY_H_
+#define _ENTROPY_H_
+
+#include <stddef.h>
+#include <stdint.h>
+
+/**
+ * entropy_read(buf, buflen):
+ * Fill the given buffer with random bytes provided by the operating system.
+ */
+int entropy_read(uint8_t *, size_t);
+
+#endif /* !_ENTROPY_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/hexify.c tarsnap-autoconf-1.0.34/libcperciva/util/hexify.c
--- tarsnap-autoconf-1.0.33/libcperciva/util/hexify.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/hexify.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,55 @@
+#include <stdint.h>
+#include <string.h>
+
+#include "hexify.h"
+
+static char hexchars[] ="0123456789abcdef0123456789ABCDEF";
+
+/**
+ * hexify(in, out, len):
+ * Convert ${len} bytes from ${in} into hexadecimal, writing the resulting
+ * 2 * ${len} bytes to ${out}; and append a NUL byte.
+ */
+void
+hexify(const uint8_t * in, char * out, size_t len)
+{
+	char * p = out;
+	size_t i;
+
+	for (i = 0; i < len; i++) {
+		*p++ = hexchars[in[i] >> 4];
+		*p++ = hexchars[in[i] & 0x0f];
+	}
+	*p = '\0';
+}
+
+/**
+ * unhexify(in, out, len):
+ * Convert 2 * ${len} hexadecimal characters from ${in} to ${len} bytes
+ * and write them to ${out}.  This function will only fail if the input is
+ * not a sequence of hexadecimal characters.
+ */
+int
+unhexify(const char * in, uint8_t * out, size_t len)
+{
+	size_t i;
+
+	/* Make sure we have at least 2 * ${len} hex characters. */
+	for (i = 0; i < 2 * len; i++) {
+		if ((in[i] == '\0') || (strchr(hexchars, in[i]) == NULL))
+			goto err0;
+	}
+
+	for (i = 0; i < len; i++) {
+		out[i] = (strchr(hexchars, in[2 * i]) - hexchars) & 0x0f;
+		out[i] <<= 4;
+		out[i] += (strchr(hexchars, in[2 * i + 1]) - hexchars) & 0x0f;
+	}
+
+	/* Success! */
+	return (0);
+
+err0:
+	/* Bad input string. */
+	return (-1);
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/hexify.h tarsnap-autoconf-1.0.34/libcperciva/util/hexify.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/hexify.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/hexify.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,22 @@
+#ifndef _HEXIFY_H_
+#define _HEXIFY_H_
+
+#include <stddef.h>
+#include <stdint.h>
+
+/**
+ * hexify(in, out, len):
+ * Convert ${len} bytes from ${in} into hexadecimal, writing the resulting
+ * 2 * ${len} bytes to ${out}; and append a NUL byte.
+ */
+void hexify(const uint8_t *, char *, size_t);
+
+/**
+ * unhexify(in, out, len):
+ * Convert 2 * ${len} hexadecimal characters from ${in} to ${len} bytes
+ * and write them to ${out}.  This function will only fail if the input is
+ * not a sequence of hexadecimal characters.
+ */
+int unhexify(const char *, uint8_t *, size_t);
+
+#endif /* !_HEXIFY_H_ */
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/humansize.c tarsnap-autoconf-1.0.34/libcperciva/util/humansize.c
--- tarsnap-autoconf-1.0.33/libcperciva/util/humansize.c	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/humansize.c	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,165 @@
+#include <stdio.h>
+
+#include "asprintf.h"
+#include "warnp.h"
+
+#include "humansize.h"
+
+/**
+ * humansize(size):
+ * Given a size in bytes, allocate and return a string of the form "<N> B"
+ * for 0 <= N <= 999 or "<X> <prefix>B" where either 10 <= X <= 999 or
+ * 1.0 <= X <= 9.9 and <prefix> is "k", "M", "G", "T", "P", or "E"; and where
+ * the value returned is the largest valid value <= the provided size.
+ */
+char *
+humansize(uint64_t size)
+{
+	char * s;
+	char prefix;
+	int shiftcnt;
+	int rc;
+
+	/* Special-case for size < 1000. */
+	if (size < 1000) {
+		rc = asprintf(&s, "%d B", (int)size);
+	} else {
+		/* Keep 10 * size / 1000^(3n) in size. */
+		for (size /= 100, shiftcnt = 1; size >= 10000; shiftcnt++)
+			size /= 1000;
+
+		/*
+		 * Figure out what prefix to use.  Since 1 EB = 10^18 B and
+		 * the maximum value of a uint64_t is 2^64 which is roughly
+		 * 18.4 * 10^18, this cannot reference beyond the end of the
+		 * string.
+		 */
+		prefix = " kMGTPE"[shiftcnt];
+
+		/* Construct the string. */
+		if (size < 100)
+			rc = asprintf(&s, "%d.%d %cB", (int)size / 10,
+			    (int)size % 10, prefix);
+		else
+			rc = asprintf(&s, "%d %cB", (int)size / 10, prefix);
+	}
+
+	if (rc == -1) {
+		warnp("asprintf");
+		goto err0;
+	}
+
+	/* Success! */
+	return (s);
+
+err0:
+	/* Failure! */
+	return (NULL);
+}
+
+/**
+ * humansize_parse(s, size):
+ * Parse a string matching /[0-9]+ ?[kMGTPE]?B?/ as a size in bytes.
+ */
+int
+humansize_parse(const char * s, uint64_t * size)
+{
+	int state = 0;
+	uint64_t multiplier = 1;
+
+	while (*s != '\0') {
+		switch (state) {
+		case -1:
+			/* Error state. */
+			break;
+		case 0:
+			/* Initial state. */
+			*size = 0;
+
+			/* We must start with at least one digit. */
+			if ((*s < '0') || (*s > '9')) {
+				state = -1;
+				break;
+			}
+
+			/* FALLTHROUGH */
+		case 1:
+			/* We're now processing digits. */
+			state = 1;
+
+			/* Digit-parsing state. */
+			if (('0' <= *s) && (*s <= '9')) {
+				if (*size > UINT64_MAX / 10)
+					state = -1;
+				else
+					*size *= 10;
+				if (*size > UINT64_MAX - (*s - '0'))
+					state = -1;
+				else
+					*size += *s - '0';
+				break;
+			}
+
+			/* FALLTHROUGH */
+		case 2:
+			/* We move into state 3 after an optional ' '. */
+			state = 3;
+			if (*s == ' ')
+				break;
+
+			/* FALLTHROUGH */
+		case 3:
+			/* We may have one SI prefix. */
+			switch (*s) {
+			case 'E':
+				multiplier *= 1000;
+				/* FALLTHROUGH */
+			case 'P':
+				multiplier *= 1000;
+				/* FALLTHROUGH */
+			case 'T':
+				multiplier *= 1000;
+				/* FALLTHROUGH */
+			case 'G':
+				multiplier *= 1000;
+				/* FALLTHROUGH */
+			case 'M':
+				multiplier *= 1000;
+				/* FALLTHROUGH */
+			case 'k':
+				multiplier *= 1000;
+				break;
+			}
+
+			/* We move into state 4 after the optional prefix. */
+			state = 4;
+			if (multiplier != 1)
+				break;
+
+			/* FALLTHROUGH */
+		case 4:
+			/* We move into state 5 after an optional 'B'. */
+			state = 5;
+			if (*s == 'B')
+				break;
+
+			/* FALLTHROUGH */
+		case 5:
+			/* We have trailing garbage. */
+			state = -1;
+			break;
+		}
+
+		/* Move on to the next character. */
+		s++;
+	}
+
+	/* Multiply by multiplier. */
+	if (*size > UINT64_MAX / multiplier)
+		state = -1;
+	else
+		*size *= multiplier;
+
+	/* Anything other than state -1 is success. */
+	return ((state == -1) ? -1 : 0);
+}
diff -ruN tarsnap-autoconf-1.0.33/libcperciva/util/humansize.h tarsnap-autoconf-1.0.34/libcperciva/util/humansize.h
--- tarsnap-autoconf-1.0.33/libcperciva/util/humansize.h	1969-12-31 16:00:00.000000000 -0800
+++ tarsnap-autoconf-1.0.34/libcperciva/util/humansize.h	2013-07-06 14:38:21.000000000 -0700
@@ -0,0 +1,21 @@
+#ifndef _HUMANSIZE_H_
+#define _HUMANSIZE_H_
+
+#include <stdint.h>
+
+/**
+ * humansize(size):
+ * Given a size in bytes, allocate and return a string of the form "<N> B"
+ * for 0 <= N <= 999 or "<X> <prefix>B" where either 10 <= X <= 999 or
+ * 1.0 <= X <= 9.9 and <prefix> is "k", "M", "G", "T", "P", or "E"; and where
+ * the value returned is the largest valid value <= the provided size.
+ */
+char * humansize(uint64_t);
+
+/**
+ * humansize_parse(s, size):
+ * Parse a string matching /[0-9]+ ?[kMGTPE]?B?/ as a size in bytes.
+ */
+int humansize_parse(const char *, uint64_t *);
+
+#endif /* !_HUMANSIZE_H_ */
